
#######################################################
#
#f[^͂̕@Ft^iqXj
#qvOFch2-12.r
#
#######################################################

library(quantreg)
library(bayesm)
data(tuna)
tau <- 0.05 #5\%ʓ_
lambda <- 10 #p[^
x <- as.matrix(cbind(1,tuna[,16:22],tuna[,9:15],log(tuna[,30]))) #ϐ
y <- log(tuna[,2]) #Star Kist 6 IXTCY̔グ
n <- nrow(x)
p <- ncol(x)
fit <- rq.fit.lasso(x,y,tau=tau,lambda=lambda) #Lasso
lambda <- fit$lambda #gpꂽp[^̒l
beta <- trunc(10^10*fit$coefficients)/10^10 #肳ꂽAW̒l
print(beta) #肳ꂽAW̕\ 

#ȉŌؖ@s
lambda <- 10^(seq(-3,2,len=20)) #gp鐳p[^̒l
cv.score <- rep(0,len=length(lambda))
for(i in 1:length(lambda)){
lam <- lambda[i]
for(l in 1:n){
x.cv <- x[-l,]
y.cv <- as.vector(y[-l])
fit <- rq.fit.lasso(x,y,tau=tau,lambda=lam) #Lasso
b.est <- trunc(10^10*fit$coefficients)/10^10  #AW̐l
pred <- sum( c(1,x[l,])*b.est ) #ړIϐ̗\
er <- y[l]-pred
cv.er <- (abs(er)+(2*tau-1)*er)/2
cv.score[i] <- cv.score[i]+cv.er 
}
}

#p[^()CVXRAicj̕\
par(cex.lab=1.2)
par(cex.axis=1.2)
plot(log(lambda),cv.score,xlab="log(Regularization parameter)",ylab="CV.score",type="l",lwd=2) 
dev.copy2eps(file="Quantile-lasso095-CVplot.ps")

#œKȐp[^̑I
opt.lambda <- lambda[subset(1:length(lambda),cv.score==min(cv.score))] 

#ŏIIȐ
fit <- rq.fit.lasso(x,y,tau=tau,lambda=opt.lambda) 
beta <- trunc(10^10*fit$coefficients)/10^10 #肳ꂽAW̒l
print(beta)@#ŏIIȐʂ̕\
