
#######################################################
#
#f[^͂̕@Ft^iqXj
#qvOFch3-03.r
#
#######################################################

library(ncvreg)

#f[^
N <- 100
P <- 200
p <- 1000
r <- 2

L <- matrix(rnorm(P*r,0,1),nrow=P,ncol=r)
F <- matrix(rnorm(N*r,0,1),nrow=N,ncol=r)
E <- matrix(rnorm(N*P,0,1),nrow=N,ncol=P)
X <- F%*%t(L)+E
W <- matrix(runif(N*p,-1,1),nrow=N,ncol=p)
Z <- cbind(F,W)

Alpha <- c(-0.8,1.6)
Beta  <- c(0.9,-0.9,rep(0,len=p-2))
Theta <- c(Alpha,Beta)

y <- Z%*%Theta+rnorm(N,0,sd=1)

#SCAD Estimation
lambda <- 0.1 #gp鐳p[^̒l
VEC <- eigen(X%*%t(X)/(P*N))$vectors
Fhat <- sqrt(N)*(VEC)[,1:r] #iK̐
Zhat <- cbind(Fhat,W)
fit <- ncvreg(X=Zhat,y=y,family="gaussian", penalty="SCAD",lambda=lambda) #SCAD 
b.est <- fit$beta #AW̐l
print(b.est)

#ȉŌؖ@s
VEC <- eigen(X%*%t(X)/(P*N))$vectors
Fhat <- sqrt(N)*(VEC)[,1:r] #iK̐
Zhat <- cbind(Fhat,W)

lambda <- c(100,10,1,0.1,0.01,0.001) #gp鐳p[^̒l
cv.score <- rep(0,len=length(lambda))
for(i in 1:length(lambda)){
lam <- lambda[i]
for(k in 1:10){
l <- ((k-1)*10+1):(k*10)
x.cv <- Zhat[-l,]
y.cv <- as.vector(y[-l])
fit <- ncvreg(X=x.cv,y=y.cv,family="gaussian", penalty="SCAD",lambda=lam) #SCAD 
b.est <- fit$beta #AW̐l
pred <- cbind(1,Zhat[l,])%*%b.est #ړIϐ̗\
er <- sum( (y[l]-pred)^2 ) #\덷
cv.score[i] <- cv.score[i]+er 
}
}

#p[^()CVXRAicj̕\
par(cex.lab=1.2)
par(cex.axis=1.2)
plot(log(lambda),cv.score,xlab="log(Regularization parameter)",ylab="CV.score",type="l",lwd=2) 

#œKȐp[^̑I
opt.lambda <- lambda[subset(1:length(lambda),cv.score==min(cv.score))] 

#ŏII SCAD 
fit <- ncvreg(X=Zhat,y=y,family="gaussian", penalty="SCAD",lambda=opt.lambda)
print(fit$beta)@#ŏIISCAD ʂ̕\
