

#######################################################
#
#f[^͂̕@Ft^iqXj
#qvOFch4-02.r
#
#######################################################

#O-Of[^̓ǂݍ
library(vcd)
data("SpaceShuttle")
Data <- SpaceShuttle[-4,]
Data <- Data[order(Data[,2]),1:5]
x <- Data[,2]
y <- Data[,5]

m <- rep(6,len=nrow(Data))
z <- cbind(y,m-y)
temp <- seq(15,85,len=100)

#fM1̐
fit <- glm(z~x,family=binomial(link="logit"))
b1 <- fit$coefficients
O <- cbind(1,temp)%*%b1
p1 <- exp(O)/(1+exp(O)) #fM1ɊÂ肳ꂽ̏m
AIC1 <- fit$aic #肳ꂽfM1AIC
print(b1) #肳ꂽfM1̉AW
print(summary(fit))

#fM2̐
fit <- glm(z~x,family=binomial(link="probit"))
b2 <- fit$coefficients
O <- cbind(1,temp)%*%b2
p2 <- pnorm(O) #fM2ɊÂ肳ꂽ̏m
AIC2 <- fit$aic  #肳ꂽfM2AIC
print(b2) #肳ꂽfM2̉AW
print(summary(fit))

#fM3̐
fit <- glm(z~x,family=binomial(link="cloglog"))
b3 <- fit$coefficients
O <- cbind(1,temp)%*%b3
p3 <- 1-exp(-exp(O)) #fM3ɊÂ肳ꂽ̏m
AIC3 <- fit$aic  #肳ꂽfM3AIC
print(b3) #肳ꂽfM3̉AW
print(summary(fit))

#茋ʂ̃vbg
par(cex.lab=1.2)
par(cex.axis=1.2)
plot(x,y/6,xlab="Temperature",ylab="Probability of failure of the O-rings",cex=1,ylim=c(0,1),xlim=c(min(temp),max(temp)))
lines(temp,p1,lwd=1,col=1)
lines(temp,p2,lwd=3,col=1,lty=2)
lines(temp,p3,lwd=3,col=1)
dev.copy2eps(file="Oring-fit.ps")

#d݃xNǧvZ
w1 <- exp(-2*AIC1)/(exp(-2*AIC1)+exp(-2*AIC2)+exp(-2*AIC3))
w2 <- exp(-2*AIC2)/(exp(-2*AIC1)+exp(-2*AIC2)+exp(-2*AIC3))
w3 <- exp(-2*AIC3)/(exp(-2*AIC1)+exp(-2*AIC2)+exp(-2*AIC3))
print(c(w1,w2,w3))

#AICɊÂf
p<- p1*w1+p2*w2+p3*w3

#茋ʂ̃vbg
par(cex.lab=1.2)
par(cex.axis=1.2)
plot(x,y/6,xlab="Temperature",ylab="Probability of failure of the O-rings",cex=1,ylim=c(0,1),xlim=c(min(temp),max(temp)))
lines(temp,p,lwd=2,col=1)
dev.copy2eps(file="Oring-MAIC.ps")

