
#######################################################
#
#f[^͂̕@Ft^iqXj
#qvOFch3-04.r
#
#######################################################

#f[^
N <- 200
P <- 1000
r <- 4
L <- matrix(rnorm(P*r,0,1),nrow=P,ncol=r)
F <- matrix(rnorm(N*r,0,1),nrow=N,ncol=r)
E <- matrix(rnorm(N*P,0,3),nrow=N,ncol=P)
X <- F%*%t(L)+E

#ő̃t@N^[
Kmax <- 20

#Estimation
Cp <- rep(0,len=Kmax)
SS <- rep(0,len=Kmax)
PEN <- rep(0,len=Kmax)
for(k in Kmax:1){
VEC <- eigen(X%*%t(X)/(P*N))$vectors
Fhat <- sqrt(N)*(VEC)[,1:k] ##t@N^[̐
Lhat <- t(Fhat)%*%X/N #t@N^[]s̐
Sk <- sum( diag( t(X-Fhat%*%Lhat)%*%(X-Fhat%*%Lhat) ) )/(N*P)
if(k==Kmax){Smax <- Sk}
Cp[k] <- Sk+k*Smax*((N+P)/(N*P))*log((N*P)/(N+P))
SS[k] <- Sk
PEN[k] <- k*Smax*((N+P)/(N*P))*log((N*P)/(N+P))
}

#t@N^[()PCXRAicj̕\
par(cex.lab=1.2)
par(cex.axis=1.2)
plot(1:Kmax,Cp,xlab="Numb. of factors",ylab="",ylim=c(0,max(Cp)+5),pch=1) 
lines(1:Kmax,SS,lwd=1,col=4,pch=1,type="p") 
lines(1:Kmax,PEN,lwd=3,col=2,pch=1,type="p") 
lines(1:Kmax,Cp,lwd=3) 
lines(1:Kmax,SS,lwd=1,col=4)
lines(1:Kmax,PEN,lwd=1,col=2,lty=3)

dev.copy2eps(file="PCA-Cp.score-Plot.ps")

